// Rule.h: interface for the CRule class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _RULE_
#define _RULE_

class CRule;
class CRuleEngine;

typedef vector<CRule> TRuleVector;
typedef vector<CRule>::iterator TRuleVectorIterator;

class CRule : public IXMLNode  
{
private:
	string m_Name;
	CRuleEngine* m_Parent;
	TConditionVector m_conds;
	TActionVector m_actions;

public:
	CRule(CRuleEngine* parent);
	virtual ~CRule();

	virtual bool set_XML( IXMLDOMNodePtr e );
	string Name() { return m_Name; };

	TConditionVector& conditions() { return m_conds; };
	TActionVector& actions() { return m_actions; };
	TActionVector* Evaluate( CQuery& query );

};

#endif // _RULE_
