//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	AbstractBasicSkills.cpp
 *  \brief implementacia metod tried CBasicSkill, CBasicSkillList, CCatch, CDribble
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++


#include "stdafx.h"
#include "player.h"
#include "AbstractBasicSkills.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////CBasicSkill/////////////////////////

CBasicSkill::CBasicSkill(int skillType, int priority, CLocalAgent *agent) 
{
	m_skillType = skillType;
	m_priority = priority;
	m_agent = agent;
	m_localSituation = new CEstimateLocalSituation;
};

CBasicSkill::~CBasicSkill()
{
	delete m_localSituation;
};

CBasicSkill::CBasicSkill(const CBasicSkill &skill) 
{
	m_skillType = skill.m_skillType;
	m_priority = skill.m_priority;
	m_agent = skill.m_agent;
	m_accel = skill.m_accel;
	m_power = skill.m_power;
	m_dir = skill.m_dir;
	m_moment = skill.m_moment;
	m_pos = skill.m_pos;
	m_skillSkillType = skill.m_skillSkillType;
}

CBasicSkill::operator=(CBasicSkill &skill) 
{
	m_skillType = skill.GetSkillType();
	m_priority = skill.GetPriority();
	m_agent = skill.GetAgent();
	m_accel = skill.m_accel;
	m_power = skill.m_power;
	m_dir = skill.m_dir;
	m_moment = skill.m_moment;
	m_pos = skill.m_pos;
	m_skillSkillType = skill.m_skillSkillType;
}; 

bool operator<(CBasicSkill  &lhs, CBasicSkill &rhs) 
{
	return(lhs.GetPriority() < rhs.GetPriority());
};

bool operator==( CBasicSkill  &lhs,  CBasicSkill &rhs) 
{
	return(lhs.GetPriority() == rhs.GetPriority());
};

bool operator<=( CBasicSkill  &lhs,  CBasicSkill &rhs) 
{
	return(lhs.GetPriority() == rhs.GetPriority());
};

void CBasicSkill::Execute()
{
};

///////////////////////////CBasicSkillList////////////////////////////////

//------------------------------------------------------
/*! \fn	void CBasicSkillList::EvaluateAndRemove() 
 *  \brief Vyhodnoti zakladnu schopnost s najvysou prioritou
 *  \return
 *  \author Rado Otipka
 *  \date 3. 12. 2001 20:20:22

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CBasicSkillList::EvaluateAndRemove() 
{
	if(!IsEmpty()) {
		int tmp =-1;
		int index = 0;
		for( int i =0;i<m_skillsList.GetSize();i++) {
			if( m_skillsList[i]->GetPriority() > tmp) {
				tmp = m_skillsList[i]->GetPriority();
				index = i;
			}
		}
		if(m_skillsList[index]->GetSkillType() == BSKILL_MANAGE) {
			if( ((CManage *) m_skillsList[index])->GetSkillSkillType() == BSKILL_MANAGE_REMOVEALL ) Empty();
		} else {
			m_skillsList[index]->Execute();
		}
		if( m_skillsList.GetSize() > 0) {
			if(m_skillsList[index] != NULL) { 
				delete m_skillsList[index];
				m_skillsList[index] =NULL;
			}
			m_skillsList.RemoveAt(index);
		}
	}		
};


void CBasicSkillList::Empty() 
{
	for( int i = 0; i<m_skillsList.GetSize(); i++ ) {
		delete m_skillsList[i];
	}
	m_skillsList.RemoveAll();
}

CBasicSkillList::CBasicSkillList() {};

////////////////////////////////CCatch/////////////////////////////////////////////

//------------------------------------------------------
/*! \fn	void CCatch::Catch( double dir )
 *  \brief chytenie lopty do ruk
 *  \param  double dir
 *  \return
 *  \author Rado Kostelnik
 *  \date 3. 12. 2001 20:21:49

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CCatch::Catch( C2DVector ballPos)
{
	if( m_localSituation->BallCatchable(GetAgent()) )
	{
		C2DVector toball = m_localSituation->RelVectorTo( GetAgent(), ballPos );
		CGameCommand *pGameCommand = new CGameCommand();
		pGameCommand->Catch(RadToDeg(AngNormalise(toball.GetAngle())));
		GetAgent()->actionseq->AddGameCommand(pGameCommand);
	}
}

CCatch::CCatch( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority ) 
{
	double m_accel = 0, posX = 0, posY = 0;
	m_accel = 0;
	TParameterBSkillsVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_ANGLE )
				sscanf( index->value.data(), "%d", &m_dir );
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY );	
}

void CCatch::Execute() 
{
	switch( m_skillSkillType ) {
	case BSKILL_CATCH_BASIC: Catch( m_pos );
		break;
	}

}




