//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Dribble.cpp
 *  \brief implementacia triedy CDribble
 *  \author Rado Otipka 
 *  \date 10. 12. 2001 18:14:09
 *  \version 

 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"
#include "LogManager.h"
#include "WorldObjects.h"
#include "AbstractBasicSkills.h"

////////////////////////////////CDribble/////////////////////////////////////////////

CDribble::CDribble( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority ):CBasicSkill( BSKILL_DRIBBLE, priority, pl ) 
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParameterBSkillsVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_ACCEL )
				sscanf( index->value.data(), "%lf", &m_accel );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY );
	m_skillSkillType = BSKILL_DRIBLE_SMART;
}


//------------------------------------------------------
/*! \fn	void CDribble::Execute()
 *  \brief vykonanie zakladnej schopnosti
 *  \param <name> <description>
 *  \return
 *  \author Rado Otipka 
 *  \date 3. 12. 2001 20:01:52

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CDribble::Execute()
{
	switch( m_skillSkillType ) {
		case BSKILL_DRIBLE_SMART:  
			SmartDrible( m_pos, m_accel );
			break;
	}
};

//------------------------------------------------------
/*! \fn	void CDribble::SmartDrible( C2DVector destPos, double accel) 
 *  \brief vedenie lopty na urcenu poziciu, 
 *  \param C2DVector destPos konecna pozicia 
 *  \param double accel zrychlenie
 *  \return
 *  \author Rado Otipka 
 *  \date 3. 12. 2001 19:38:14
 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CDribble::SmartDrible( C2DVector destPos, double accel) 
{
	C2DVector topos = m_localSituation->RelVectorTo(GetAgent(), destPos);
	//C2DVector vBall = GetAgent()->GetWorldModel()->GetBall()->GetSpeed();
	//C2DVector vPa  = GetAgent()->GetSpeed();
	//topos.GetAngle
	//C2DVector  final = vBall + vPa;
	C2DVector ballPos = GetAgent()->GetWorldModel()->GetBall()->GetPosition();
	C2DVector agentPos = GetAgent()->GetPosition();
	fprintf(m_ff, "Dribble current time: %d \n", GetAgent()->GetTime().m_nPlayTime);
	if( GetAgent()->GetTime().m_nPlayTime - GetAgent()->GetWorldModel()->GetBall()->m_cLastVisible.m_nPlayTime > 4) {
		GetAgent()->listSkl->Empty(); // kym sa nezosinchronizujeme s timy hore
		return;
	}
    if (m_localSituation->BallKickable(GetAgent())) {
		if( (destPos - agentPos).GetDistance() < (destPos - ballPos).GetDistance() ) {
			CKick(BSKILL_KICK_WITH_ACCEL_BYPASS, 50, destPos ,GetAgent(),0).Execute();
			GetAgent()->listSkl->AddSkill(new CTurn( BSKILL_TURN_2,topos.GetAngle(),GetAgent(),101 ));
			return;
		} else {
			CKick(BSKILL_KICK_WITH_ACCEL_BYPASS, 20, destPos ,GetAgent(),0).Execute();
		}
		if( topos.GetAngle() > 7 || topos.GetAngle() <7 )
			GetAgent()->listSkl->AddSkill(new CTurn( BSKILL_TURN_2,topos.GetAngle(),GetAgent(),101 ));

		GetAgent()->listSkl->AddSkill(new CMove( BSKILL_MOVE_DASH , accel ,GetAgent(),101));	
    } else {
		C2DVector nextBallPos = m_localSituation->BallPosition( GetAgent(), GetAgent()->GetTime().m_nPlayTime + 1);
		CMove( BSKILL_MOVE_GOTO , nextBallPos, 100, GetAgent(), 0).Execute();	
     }
	if( (destPos - GetAgent()->GetPosition()).GetDistance() > 2 ) 
		GetAgent()->listSkl->AddSkill( new CDribble( BSKILL_DRIBLE_SMART, destPos,accel, GetAgent(), 99 ) );
};
