#ifndef GAMESTATE
#define GAMESTATE

#include "GameTime.h"


enum EPlayMode {
	PM_NONE = 0,
	PM_UNKNOWN_STOP,
	PM_UNKNOWN_NOSTOP,
	PM_BeforeKickOff,
	PM_TimeOver,
	PM_PlayOn,
	PM_DropBall,

	PM_LOCALMODE         = 0x08,

	PM_KickOff_Left      = 0x08,
	PM_KickOff_Right     = 0x09,
	PM_KickIn_Left       = 0x0A,
	PM_KickIn_Right      = 0x0B,
	PM_FreeKick_Left     = 0x0C,
	PM_FreeKick_Right    = 0x0D,
	PM_CornerKick_Left   = 0x0E,
	PM_CornerKick_Right  = 0x0F,
	PM_GoalKick_Left     = 0x10,
	PM_GoalKick_Right    = 0x11,
	PM_AfterGoal_Left    = 0x12,
	PM_AfterGoal_Right   = 0x13,
	PM_OffSide_Left      = 0x14,
	PM_OffSide_Right     = 0x15,
};

// ciselne musi byt totozne s EPlayMode
enum ELocalPlayMode {
	PML_NONE = 0,
	PML_UNKNOWN_STOP,
	PML_UNKNOWN_NOSTOP,
	PML_BeforeKickOff,
	PML_TimeOver,
	PML_PlayOn,
	PML_DropBall,

	PML_LOCALMODE         = 0x08,

	PML_KickOff_My        = 0x08,
	PML_KickOff_Opp       = 0x09,
	PML_KickIn_My         = 0x0A,
	PML_KickIn_Opp        = 0x0B,
	PML_FreeKick_My       = 0x0C,
	PML_FreeKick_Opp      = 0x0D,
	PML_CornerKick_My     = 0x0E,
	PML_CornerKick_Opp    = 0x0F,
	PML_GoalKick_My       = 0x10,
	PML_GoalKick_Opp      = 0x11,
	PML_AfterGoal_My      = 0x12,
	PML_AfterGoal_Opp     = 0x13,
	PML_OffSide_My        = 0x14,
	PML_OffSide_Opp       = 0x15,
};

#define isValidPlayMode(x)  ((x != PM_NONE) && (x != PM_UNKNOWN_NOSTOP))
#define isStopMode(x) ((x == PM_BeforeKickOff) || (x == PM_OffSide_Left) || (x == PM_OffSide_Right) || (x == PM_NONE))

class CGameState
{
    EPlayMode m_nPlayMode;
    CGameTime m_tGameTime;
//  Score
//  Side??

public:
	CGameState();

    CGameTime GetGameTime() { return m_tGameTime; };
    EPlayMode GetPlayMode() { return m_nPlayMode; };

    void SetGameTime(CGameTime &tGameTime) { m_tGameTime = tGameTime; };
    EPlayMode SetPlayMode(EPlayMode nPlayMode) { return m_nPlayMode = nPlayMode; };
};

#endif  // GAMESTATE