#include "stdafx.h"
#include "LogManager.h"
#include "WorldObjects.h"
#include "AbstractBasicSkills.h"

#define POWERRANGE(x)  (((x)>GetAgent()->cfg->maxpower)?GetAgent()->cfg->maxpower:             \
                        (((x)<GetAgent()->cfg->minpower)?GetAgent()->cfg->minpower:(x)))
#define MOMENTRANGE(x) (((x)>GetAgent()->cfg->maxmoment)?GetAgent()->cfg->maxmoment:           \
                        (((x)<GetAgent()->cfg->minmoment)?GetAgent()->cfg->minmoment:(x)))
#define NECKRANGE(x)   (((x)>GetAgent()->cfg->maxneckmoment)?GetAgent()->cfg->maxneckmoment:   \
                        (((x)<GetAgent()->cfg->minneckmoment)?GetAgent()->cfg->minneckmoment:(x)))

#define MINTURN  0.001

// FIXME: pre aku neurcitost sa pozerat za loptou
#define INVALID(diff, dist) ((((dist)>5) && ((diff)>(0.5*(dist)))) || (((dist)<5) && ((diff)>3)))
/////////////////////////////////////////////////////////////////////////////////////////////
CMove::CMove( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority ) :CBasicSkill( BSKILL_MOVE, priority, pl )  
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParameterBSkillsVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_ACCEL )
				sscanf( index->value.data(), "%lf", &m_accel );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
		if( index->name == VALUE_PLAYER )
				sscanf( index->value.data(), "%d", &m_playerNumber );			
	}
	m_pos = C2DVector( posX, posY ); 	
}
/////////////////////////////////////////////////////////////////////////////////////////////
void CMove::Execute() 
{
	switch( m_skillSkillType) {
	case BSKILL_MOVE_DASH:
		Dash( m_power );
		break;
	case BSKILL_MOVE_GOTO:
		GoTo( m_pos, m_accel);
		break;
	case BSKILL_MOVE_FACETOGO:
		FaceGoTo( m_movObj,  m_pos,  m_accel);
		break;
	case BSKILL_MOVE_TO: 
		Move( m_x, m_y );		
		break;
	case BSKILL_MOVE_GOTO_PLAYER:
		GoToPlayer( m_playerNumber );
		break;
	}
};


void CMove::Dash(  double power)
{
    CGameCommand *pGameCommand = new CGameCommand();

    pGameCommand->Dash(POWERRANGE(power));
    GetAgent()->actionseq->AddGameCommand(pGameCommand);
}


void CMove::Move(  double x, double y)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Move(x, y);
    GetAgent()->actionseq->AddGameCommand(pGameCommand);
}

void CMove::Move(  C2DVector pos)
{
    Move(pos.GetX(), pos.GetY());
}

//******************************************************
/*! \fn	void CMove::GoTo(  C2DVector pos, double accel)
 *  \brief zdgxdfghxfghdfghsfg
 *  \param <name> <description> 
 *  \return
 *  \author Rado Otipka 
 *  \date 2. 12. 2001 17:21:57

 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CMove::GoTo(  C2DVector pos, double accel)
{
    C2DVector topos = m_localSituation->RelVectorTo(GetAgent(), pos);
    double ang = topos.GetAngle();
	//C2DVector deltaPos = 	GetAgent()->GetPosition() - pos;

    if (topos.GetDistance() < GetAgent()->cfg->kickable_area)  return;

    // zistujeme, ci je v ceste nejaky hrac
    CAgent *paiw = m_localSituation->PlayerInWay(GetAgent(), ang);
    if (0) { //rado
        // tu sa riesi vyhybanie sa hracovi
        C2DVector toplr = m_localSituation->RelVectorTo(GetAgent(), paiw->GetPosition());
        double pldist = toplr.GetDistance();
        double pldir = toplr.GetAngle();
        LOGMSG(1, "player in way - dist %lf, dir %lf",pldist,pldir);

        LOGMSG(1, "ang before %lf", ang);
        // vyhybame sa iba ked je hrac blizsie ako miesto kam chceme ist
        if (pldist < topos.GetDistance())
            (pldir < ang) ? ang -= m_localSituation->MinimalDirection(GetAgent(), pldist) + fabs(pldir - ang)
                          : ang += m_localSituation->MinimalDirection(GetAgent(), pldist) + fabs(pldir - ang);
        LOGMSG(1, "ang after  %lf", ang);
    
    }

    //double mindir = DegToRad(5.0); // aby sme sa stale netocili
	double mindir = DegToRad( 10 - 8*exp(-topos.GetDistance() * 0.2f ));
    if ((ang > -mindir) && (ang < mindir)) 
    {
        if (accel==0) { 
            // vypocet accel, aby tam agent presne zastavil
            accel = (topos - (C2DVector)GetAgent()->GetSpeed()).GetDistance();
        }		
	    
        Dash2( accel );
/*		if ((GetAgent()->GetPosition() - m_pos).GetDistance() <= 3) {
		    nPlanTime = 0;
			pa->tdata->SetPlanPos(nPlanTime, cPlanPos, cPlanPosPrec);
			return false;
	    }*/
		//if( accel  )
    }
    else 
    {
		  CTurn(BSKILL_TURN_2, ang, GetAgent(), 0).Execute(); // Rado Otipka 2. 12. 2001 15:27:41
//        Turn2(GetAgent(), ang); //dorobit
    }
	/*if( (destPos - GetAgent()->GetPosition()).GetDistance() > 2 ) {
		GetAgent()->listSkl->AddSkill( new CMove(BSKILL_MOVE_GOTO,pos,100, GetAgent(),98 ) );
	}*/
}


void CMove::FaceGoTo(  CMovingObject *faceobj, C2DVector pos, double accel)
{
//    TurnNeckTo(GetAgent(), facepos);
//    GoTo(GetAgent(), pos, accel);

//    static int rr=0;
//    if (rr) TurnNeckTo(GetAgent(), facepos);
//    else    GoTo(GetAgent(), pos, accel);
//    rr = !rr;

	// added by frz

	// maximalne mozne natocenie krku
	double maxneckang = GetAgent()->cfg->Getd("maxneckang");

	// natocenie hlavy a krku
	C2DVector mypos = GetAgent()->GetPosition();
	double mydir = GetAgent()->GetDirection();
	double myheaddir = GetAgent()->GetNeckDirection();

	TRACE("\t\t\t\tMoje natocenie: telo %f, hlava %f\n", RadToDeg(mydir), RadToDeg(myheaddir));

	// vektor a uhol k cielu
	C2DVector reldestpos = pos - mypos;
	double reldestdir = reldestpos.GetAngle();

	// musim sa tocit ak chcel ist k cielu
	double turnangle = AngNormalise(reldestdir - mydir);

	double relfodir;
	double neckturnangle = 0.0;
	C2DVector fopos = faceobj->GetPosition();
	C2DVector relfopos = fopos - mypos;

	double diff = faceobj->GetPosition().GetDiffusion();
	double dist = relfopos.GetDistance();
	// ak viem kde je objekt na ktory sa chcem pozerat
	if ((((faceobj->GetSeeStatus() & SEE_ANGLE) && (faceobj->GetSeeStatus() & SEE_DISTANCE)) ||
        ((faceobj->GetSeeStatus() & EXPECTED_ANGLE) && (faceobj->GetSeeStatus() & EXPECTED_DISTANCE))) &&
        (!INVALID(diff,dist)))    
// ISVALID:     (IsValid(GetAgent()->GetPosition(),faceobj->GetPosition())))    // test (!INVALID(diff,dist)))    
    {	
		relfodir = relfopos.GetAngle();
	}
	// ak neviem kde je objekt tocim sa dokola aby som ho nasiel
	else {
		relfodir = 45 + mydir;
	}
	bool goback = false;

	TRACE("\t\t\t\t");
	
		// zistim ci musim cuvat aby som mohol pozorovat objekt
	if(fabs(AngNormalise(reldestdir - relfodir)) > DegToRad(maxneckang)) {
		turnangle = AngNormalise(turnangle + DegToRad(180));
		goback = true;

		TRACE("Budem cuvat:");
	}

	TRACE("turnangle %f\n", RadToDeg(turnangle));

	// zistim natocenie krku
	neckturnangle = AngNormalise(relfodir - myheaddir);

	TRACE("\t\t\t\tneckturnangle %f\n", RadToDeg(neckturnangle));

	// vypocitam silu behu
	if(accel == 0) {
		double powerrate = GetAgent()->cfg->Getd("dash_power_rate");
		accel = ((reldestpos - GetAgent()->GetSpeed())/powerrate).GetDistance();
	}

	if(goback)
		accel *= -1;
		//CTurn(
	if(fabs(turnangle) > DegToRad(7.0))
		CTurn(BSKILL_TURN_ME, turnangle, GetAgent(), 0).Execute();
//		Turn(GetAgent(), turnangle);       //rado29.11.2001
	else if(fabs(neckturnangle - turnangle) > DegToRad(4.0)) 
		CTurn(BSKILL_TURN_NECK, turnangle, GetAgent(), 0).Execute();
//		TurnNeck(GetAgent(), neckturnangle);  //rado29.11.2001
	else
		Dash( accel); 	
	// if(fabs(neckturnangle - turnangle) > DegToRad(4.0))
	// 	TurnNeck(GetAgent(), neckturnangle);
}

void CMove::Dash2( double accel)
{
    Dash(DashRealToWanted( accel));
}


double CMove::DashRealToWanted(double accel)
{
    // todo: zapocitat staminu

    return accel / (GetAgent()->cfg->dash_power_rate);
	//return accel ;
}

void CMove::GoToPlayer( int number ) 
{
   if( number == GetAgent()->GetPlayerNumber() ) return; //mam nahrat sam sebe ?
   C2DVector posAgent(0,0);
   int agentsCount = GetAgent()->GetWorldModel()->GetIdentifiedAgentsCount();
   ESide tMySide = GetAgent()->GetPlayerSide();
   for(int i=0; i < agentsCount; i++) {
		CAgent *agent = GetAgent()->GetWorldModel()->GetIdentifiedAgent(i);
		if( agent->GetPlayerSide() == tMySide ) {
			if( agent->GetPlayerNumber() == number ) {
				posAgent = agent->GetPosition();
			}
		}
   }
   if( i == agentsCount ) return; //svojho agenta s takym cislom nevidim 
   else  {
	  CMove(BSKILL_MOVE_GOTO, posAgent, 0 ,GetAgent(),0).Execute();
   }
}