#ifndef PERCEPTIONTYPES_H
#define PERCEPTIONTYPES_H

#include "types.h"

#define INTERRUPTS_PER_SIMSTEP     10
#define INTERRUPTS_TO_DELIBERATE    5
#define INTERRUPTS_TO_SEND          3

#define NOT_EXISTING -32000

#define OUR_GOAL        0
#define OPP_GOAL        1

enum EMsgType {
    MT_NoMsg,
    MT_See,
    MT_Hear,
    MT_SenseBody,
    MT_Init
};

enum EFlagType {
    FT_NoFlag,
    FT_C,
    FT_LT,
    FT_LB,
    FT_CT,
    FT_CB,
    FT_RT,
    FT_RB,
    FT_PLT,
    FT_PLC,
    FT_PLB,
    FT_PRT,
    FT_PRC,
    FT_PRB,
    FT_GLT,
    FT_GLB,
    FT_GRT,
    FT_GRB,
    FT_TL10,
    FT_TL20,
    FT_TL30,
    FT_TL40,
    FT_TL50,
    FT_TR10,
    FT_TR20,
    FT_TR30,
    FT_TR40,
    FT_TR50,
    FT_BL10,
    FT_BL20,
    FT_BL30,
    FT_BL40,
    FT_BL50,
    FT_BR10,
    FT_BR20,
    FT_BR30,
    FT_BR40,
    FT_BR50,
    FT_LT10,
    FT_LT20,
    FT_LT30,
    FT_LB10,
    FT_LB20,
    FT_LB30,
    FT_RT10,
    FT_RT20,
    FT_RT30,
    FT_RB10,
    FT_RB20,
    FT_RB30,
    FT_T0,
    FT_B0,
    FT_L0,
    FT_R0,

    FT_COUNT,
};

enum ELineType {
    LT_NoLine=-1,
    LT_L=0,
    LT_R,
    LT_T,
    LT_B,
    LT_Y,
    LT_COUNT
};

enum EGoalType {
    GT_NoGoal,
    GT_L,
	GT_HOME = GT_L, // + 10.12.2001 Anton Weissensteiner & Martin Spal 
    GT_R,
	GT_OPPONENT = GT_R, // + 10.12.2001 Anton Weissensteiner & Martin Spal
    GT_COUNT
};

enum EHearMsgType {
    MT_Nobody,
    MT_Referee,
    MT_Self,
    MT_Other
};


// toto sa mi vidi logickejsie, ako v enume vymenovane vsetky moznosti....

/*
enum ESetValues {
		SV_None = 0,
		SV_DirChng,
		SV_DistChng,
		SV_DirChngDistChng,
		SV_Dir,
		SV_DirDirChng,
		SV_DirDistChng,
		SV_DirDistChngDirChng,
		SV_Dist,
		SV_DistDirChng,
		SV_DistDistChng,
		SV_DistDistChngDirChng,
		SV_DistDir,
		SV_DistDirDirChng,
		SV_DistDirDistChng,
		SV_DistDirDistChngDirChng
};
*/
enum EViewQuality {
    VQ_None,
    VQ_Low,
    VQ_High
};

enum EViewWidth {
    VW_None,
    VW_Narrow,
    VW_Normal,
    VW_Wide
};

enum ESide {
    S_None=0,
    S_Left=1,
	S_HOME = S_Left,
    S_Right=2,
	S_OPPONENT = S_Right
};

#endif  // PERCEPTIONTYPES_H
