// Player.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Player.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "ChildTextFrame.h"

#include "Config.h"

#include "version.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp

BEGIN_MESSAGE_MAP(CPlayerApp, CWinApp)
	//{{AFX_MSG_MAP(CPlayerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp construction

CPlayerApp::CPlayerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPlayerApp object

CPlayerApp theApp;

CConfig *cfg = NULL;

extern string g_sTeamName;
extern string g_sServerAddress;
extern UINT g_sServerPort;

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp initialization

// FIXME: brrr....
class CCmdLineInfo: public CCommandLineInfo
{
public:
    string m_sAgentCfgName;

    virtual void ParseParam(LPCTSTR lpszParam, BOOL bFlag, BOOL bLast);
    CCmdLineInfo() { m_sAgentCfgName = "agent.conf"; }
};

void CCmdLineInfo::ParseParam(LPCTSTR lpszParam, BOOL bFlag, BOOL bLast)
{
    // prvy arcument, ktory nie je typ 
    if (!bFlag) {
        m_sAgentCfgName = lpszParam;
    }
}


BOOL CPlayerApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMDIFrameWnd* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create main MDI frame window
	if (!pFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;

	// try to load shared MDI menus and accelerator table
	//TODO: add additional member variables and load calls for
	//	additional menu types your application may need. 

	HINSTANCE hInst = AfxGetResourceHandle();
	m_hMDIMenu  = ::LoadMenu(hInst, MAKEINTRESOURCE(IDR_MAINFRAME));
	m_hMDIAccel = ::LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_MAINFRAME));

    // defaultne nastavenia vizualizatora
	m_bDrawPerceptions = true;
	m_bDrawTeammateInfo = true;
	m_bDrawOpponentInfo = true;
	m_bDrawBallInfo = true;
	m_bDrawLocalAgentInfo = true;

	// The main window has been initialized, so show and update it.
	pFrame->ShowWindow(m_nCmdShow);
	pFrame->UpdateWindow();

    CCmdLineInfo cCmdInfo;
	ParseCommandLine(cCmdInfo);

    // FIXME
    ::cfg = new CConfig;
    ::cfg->Load("server.conf");
    ::cfg->Load(cCmdInfo.m_sAgentCfgName);
    ::cfg->AssignValues();

    g_sServerAddress = ::cfg->app_connect_server;
    g_sServerPort = ::cfg->app_connect_port;
    g_sTeamName = ::cfg->app_team_name;
    if (::cfg->app_autoconnect) {
        if (::cfg->app_autoconnect_goalie) {
            ((CMainFrame *)m_pMainWnd)->OnServerConnectGoalie();
        } else {
            ((CMainFrame *)m_pMainWnd)->OnServerConnect();
        }
        if (::cfg->app_autoconnect_dummy) {
            Sleep(1000);
            ((CMainFrame *)m_pMainWnd)->OnServerDisconnect();
        }
    }

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp message handlers

int CPlayerApp::ExitInstance() 
{
    if (::cfg) { delete ::cfg;  ::cfg = NULL; }

	//TODO: handle additional resources you may have added
	if (m_hMDIMenu != NULL)
		FreeResource(m_hMDIMenu);
	if (m_hMDIAccel != NULL)
		FreeResource(m_hMDIAccel);

	return CWinApp::ExitInstance();
}

void CPlayerApp::OnFileNew() 
{
	CMainFrame* pFrame = STATIC_DOWNCAST(CMainFrame, m_pMainWnd);

	// create a new MDI child window
   	if (pFrame->m_pCoordinatorThread) {
	    pFrame->CreateNewChild(
		    RUNTIME_CLASS(CChildFrame), IDR_MAINFRAME, m_hMDIMenu, m_hMDIAccel);
    }
}

void CPlayerApp::OnFileTextNew()
{
	CMainFrame* pFrame = STATIC_DOWNCAST(CMainFrame, m_pMainWnd);

	// create a new MDI child window
    if (pFrame->m_pCoordinatorThread) {
	    pFrame->CreateNewChild(
		    RUNTIME_CLASS(CChildTextFrame), IDR_MAINFRAME, m_hMDIMenu, m_hMDIAccel);
    }
}



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_version;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_version = _T(" ");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_VERSION_ID, m_version);
	DDV_MaxChars(pDX, m_version, 25);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CPlayerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.m_version.Format( "%s", VersionStr );
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp message handlers

