// ParameterQuery.h: interface for the CParameterQuery class
//
//////////////////////////////////////////////////////////////////////

#ifndef _PARAMETERQUERY_H_
#define _PARAMETERQUERY_H_

class CParameterQuery;

#include "ruleparser.h"
#include "worldobjects.h"

class CParameterQuery : public CQuery
{
public:
	CParameterQuery(CLocalAgent *pAgent = NULL );
};


class CBestLocatedTeamMateTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBestLocatedTeamMateTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "BestLocatedTeamMate";
	};

	string Evaluate();
};

class CFreePositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CFreePositionTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "FreePosition";
	};

	string Evaluate();
};

class CBestLocationForPassTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBestLocationForPassTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "BestLocationForPass";
	};

	string Evaluate();
};

class CActionPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CActionPositionTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "ActionPosition";
	};

	string Evaluate();
};

class CStrategicPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CStrategicPositionTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "StrategicPosition";
	};

	string Evaluate();
};

class CBallInterceptPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBallInterceptPositionTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "BallInterceptPosition";
	};

	string Evaluate();
};

class CBallPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBallPositionTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "BallPosition";
	};

	string Evaluate();
};

class CGoalTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CGoalTerm( CLocalAgent *pAgent )
	:	m_pAgent(pAgent)
	{
		name = "Goal";
	};

	string Evaluate();
};

#endif // _PARAMETERQUERY_H_
